// Abstarct base class for a player interface
// Statistical methods in particle physics, exercise 6
// Niklaus Berger, 10.11.2011

#ifndef __BASEPLAYER_H
#define __BASEPLAYER_H

#include <string>

using std::string;

class BasePlayer{
 public:
  BasePlayer();
  ~BasePlayer();
  // Implementations have to ensure that the return value is <= the argument
  // This function is used when the class is the first player
  virtual double ReceiveAndForwardMoneyA(double received_amount) =0;
  // Implementations have to ensure that the return value is <= the argument
  // This function is used when the class is the second player
  virtual double ReceiveAndForwardMoneyB(double received_amount) =0;
  virtual void RecieveMoneyBack(double received_amount) =0;
  // Return the amount of money collected so far
  virtual double GetBalance() const =0;
  // Return the name of the class
  virtual string GetName() const =0;
};


#endif
