#include  "Christian.h"
#include  "math.h"
using namespace std;
Christian::Christian(){
  k = 2.2;

  balance = 0;

  round = 0;

  M = 0;
  startAsA = false;

  corAA = true;
  corAB = true;
  corBA = true;
  corBB = true;

  testCorA = false;
  testCorB = false;

  fracGiftA = 0;
  fracGiftB = 0;

  iLastGiftA = 0;
  iLastGiftB = 0;

  rST = 8; // Round when the testing Starts
};


Christian::~Christian(){

};

double Christian::ReceiveAndForwardMoneyA(double received_amount) {
  if(round == 0) {
    //Determine who is A and B
    startAsA = true;
  }

  if(M == 0) M = received_amount; // Set M

  //cout << "\t Round (A) " << round << " ("<< this->GetName()<<"): " << balance << " + " << received_amount << endl;
  balance += received_amount;

  double gift = 0;
  
  // First back and forth round: dont gift anything
  if(round <= 1) gift = 0;
  //Start generously
  if(round == 2 || round == 3) gift = M;
  if(round > 3) {
    //gift as long as it makes profit
    if(fracGiftB < 1.0/k) {
      gift = 0;
    } else {
      //Tit for Tat
      gift = min(M,M*(fracGiftA));
    } 
  }

  // Test for Correlations
  if(round == rST || round == rST+1) {
    testCorA = true;
    gift = M*fracGiftA*0.9;
  }

  // If there is a correlation assume tit for tat or something similiar
  // --> be generous to get the exchange perfectly running again
  if(round == rST+2 || round == rST+3) {
    testCorA = false;
  }
  if((round == rST+2 || round == rST+3) && ((corAA) || (corAB))) {
    fracGiftA = 1;
    gift = M;
  }



  //If Testing is over
  // This will cost me in 20 round ~ 10 but opponent ~ 100 for a 
  // const opponent with fracA = 0.5 and fracB = 0.5
  // Too risky
  //if((round >= rST+10) && !(corAA) && !(corAB)) gift = 0;

  iLastGiftA = gift;

  balance -= gift;

  //cout << "\t Frac A: " << fracGiftA << " Frac B: "<< fracGiftB << " " << corAA << " " << corAB << " " << corBA << " " << corBB << " M = " << M<< endl;

  round++;
  return gift;
}


double Christian::ReceiveAndForwardMoneyB(double received_amount) {
  //cout << "\t Round (B) " << round << " ("<< this->GetName()<<"): " << balance << " + " << received_amount << endl;
  balance += received_amount;

  double gift = 0;

  if(M != 0) {
    double newFracGiftA = received_amount/M/k;
    //Test Correlations
    if(testCorA) {
      if(newFracGiftA == fracGiftA) corAA = false;
    } else if(testCorB) {
      if(newFracGiftA == fracGiftA) corBA = false;
    } else {
      // dont change fracGiftA if in testmode
      fracGiftA = newFracGiftA;
    }
  }
  
  // First back and forth round: dont gift anything
  if(round <= 1) gift = 0;

  // Start generously
  if(round == 2 || round == 3) gift = received_amount*0.5;
  // Tit for Tat
  if(round >= 4 || round >= 5) {
    gift = received_amount*fracGiftB;
  }
  if(round == rST+4 || round == rST+5) {
    testCorB = true;
    gift = received_amount*fracGiftB*0.95;
  }
  
  //End Testing Mode
  if(round == rST+6 || round == rST+7) {
    testCorB = false;
  }
  
  //Keep the game runnig if there is a correlation for B
  if((round == rST+6 || round == rST+7 || round == rST+6 || round == rST+7) && (corBA || corBB)){
    gift = received_amount*0.5;
    fracGiftB = 0.5;
  }

  // If Testing is over:
  // if his choice is not related to my choice of giftB
  //  -> Dont give him anything
  if((round >= rST+10) && !(corBA) && !(corBB)) gift = 0;

  //Last round, this cannot be punished
  if(round == 19999) gift = 0;

  iLastGiftB = gift;

  balance -= gift;

  //cout << "\t Frac A: " << fracGiftA << " Frac B: "<< fracGiftB << " " << corAA << " " << corAB << " " << corBA << " " << corBB << " M = " << M<< endl;

  round++;
  return gift;
}

void Christian::RecieveMoneyBack(double received_amount) {
  //cout << balance << " + " << received_amount << endl;
  if(iLastGiftA != 0 && k != 0) {
    double newFracGiftB = received_amount/iLastGiftA/k;
    //Test Correlations
    if(testCorB) {
      if(newFracGiftB == fracGiftB) corBB = false;
    } else if(testCorA) {
      if(newFracGiftB == fracGiftB) corAB = false;
    }
    balance += received_amount;
    fracGiftB = newFracGiftB;
  }
}

double Christian::GetBalance() const {
  return balance;
}
string Christian::GetName() const {
  return "Christian";
}

