#ifndef DOMINIK_H
#define DOMINIK_H

#include "BasePlayer.h"
#include <algorithm>
#include <cassert>

using namespace std;

class Dominik : public BasePlayer {
private:
	const double M;
	double cautiousness;
	double unforgiviness;
	double trust;
	double satisfaction;
	double investment;
	const int brainsize;
	double brain[30];
	double weight[30];

	double alpha;

	double money;
	double impression;

	double balance;
	double returned_money;
	
	double last_income;
	double last_return;


	int roundA;

public:

	Dominik(double dummy1 = 1., double dummy2 = 1.) :  BasePlayer(), M(100), brainsize(30) {
		
		roundA = 0;
		money = 0;
		balance = 0;

		trust = 0.5;
		cautiousness = 0.1;
		satisfaction = 0.01;
		alpha = 4; 
		unforgiviness = 0.95;

		last_income = 1;
		last_return = 0;


		for(int i = 0; i < brainsize; i++) {
			brain[i] = 0;
			weight[i] = 1;
		}
	}



	double ReceiveAndForwardMoneyA(double received_amount) {
		investment = (received_amount * trust);
		if(roundA < 1) {
			investment = 0.;
		}
		money = received_amount - investment;
		return investment;
	}

	void RecieveMoneyBack(double received_amount) {
		money += received_amount;
		balance += money;


		if(investment != 0)
			impression = pow(received_amount/(investment *2.2) + satisfaction*2.2/1.2, alpha);
		else 
			impression = 0.5;
		impression = min(impression, 1.);
		impression = max(impression, 0.);

		double penalty;
		if(impression - brain[0] > 0) {
			penalty = 1;
		}
		else
		{
			cautiousness = 0.5;
			penalty = 10 * trust;
		}



		for(int i = 0; i < brainsize-1; i++) {
			brain[i] = brain[i+1];
			weight[i] = weight[i+1] * unforgiviness * penalty;
		}
		brain[brainsize-1] = impression;
		weight[brainsize-1] = 1.;


		double temp = 0;
		trust = 0;
		int start = (int)(brainsize/cautiousness);
		start = min(start, brainsize-1);
		for(int i = start; i < brainsize; i++) {
			trust += brain[i]/weight[i];
			temp += weight[i];
		}
		trust = min(trust/temp, 1.);
		trust = max(trust, 0.);

		cautiousness = max(cautiousness-0.05, 0.00001);
		

		roundA++;
	}


	double ReceiveAndForwardMoneyB(double received_amount) {

		money = received_amount;
		balance += received_amount;
		return 0;
		
	}

	double GetBalance() const {
		return balance;
	}


	string GetName() const {
		return "Dominik";
	}
};

#endif
