#include "buschmann.h"

buschmann::buschmann()
{
	_M = 0.0;
	_MoneyB = 0.0;
	_given = 0.0;
};

buschmann::~buschmann()
{};

double buschmann::ReceiveAndForwardMoneyA(double recieved_amount)
{	
	//look if Player B has same amount of money than Player A
	//if Player B has more than Player A, react by forwarding less money
	double trust_factor = 1.0;
	if( _M < _MoneyB -0.1 ) 
		trust_factor = _M/(_MoneyB*2.0) ;	

	_M += recieved_amount;
	double forward_amount = recieved_amount*trust_factor;
	_given = forward_amount;	
	_M -= forward_amount;
	return forward_amount;
};

double buschmann::ReceiveAndForwardMoneyB(double recieved_amount)
{	
	_M += recieved_amount;
	//keep half the money. As long as Player B doesn't know the initial M 
	//its hard to react on the behaviour of Player A. 
	//If Player A will forward the complete money this value will give rise 
	//to an equal number of money for both players.
	double forward_amount = recieved_amount/2.8;
	_M -= forward_amount;
	return forward_amount;
};

void buschmann::RecieveMoneyBack(double recieved_amount)
{
	//keep track of the money of player B
	_MoneyB += 2.2*_given - recieved_amount;
	_M += recieved_amount;
};

double buschmann::GetBalance() const
{
	return _M;
}

string buschmann::GetName() const
{
	return "buschmann";
};
