//Main Program for exercise 7

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <vector>
// include your own class header file here
#include "buschmann.h"
#include "GerickPlayer.h"
#include "Nikolai.h"
#include "Player_but.h"
#include "DerImperatorZockt.h"
#include "dynamicstrat.h"
#include "FabePlayer.h"
#include "HeikoPlayer.h"
#include "MitzelPlayer.h"
#include "Schwiegermutter.h"
#include "LudwigPlayer.h"
#include "StolziPlayer.h"
#include "Andreas.h"
#include "Rainer.h"
#include "Player.h"
#include "GiftGame.h"
#include "Christian.h"
#include "PlayerJohannBrehmer.h"
#include "Dominik.h"

using namespace std;

void FillVector(vector<BasePlayer *> &players){
  players.clear();
  
  players.push_back(new buschmann());
  players.push_back(new GerickPlayer());
  players.push_back(new Nikolai());
  players.push_back(new Player_but());
  players.push_back(new DerImperatorZockt());
  players.push_back(new dynamicstrat());
  players.push_back(new FabePlayer("FabePlayer"));
  players.push_back(new HeikoPlayer());
  players.push_back(new MitzelPlayer());
  players.push_back(new Schwiegermutter());
  players.push_back(new LudwigPlayer());
  players.push_back(new StolziPlayer());
  players.push_back(new Andreas());
  players.push_back(new Rainer());
  players.push_back(new Player());
  players.push_back(new GiftGame());
  players.push_back(new Christian());
  players.push_back(new PlayerJohannBrehmer());
  players.push_back(new Dominik());
}



int main(int argc,char** argv){
  
  cout << "Welcome to exercise 7" << endl;

  const double k = 2.2;

  cout << "k is " << k << endl;

  const double M = 100.0;
  
  cout << "M is " << M << endl;

  const unsigned int nplayers =19;

  vector<BasePlayer *> playersA;
  vector<BasePlayer *> playersB;
  
  vector<double> balance(nplayers,0.0);
 
  ofstream outfile;
  outfile.open("results.txt");


  // first game round
  for(unsigned int i =0; i < nplayers; i++){
    for(unsigned int j =0; j < nplayers; j++){
      FillVector(playersA);
      FillVector(playersB);
      int bindex = (i+j)%nplayers;
      //cout << "A :" << playersA[i]->GetName() << endl;
      //cout << "B :" << playersB[bindex]->GetName() << endl;
      
      double AtoB = playersA[i]->ReceiveAndForwardMoneyA(M);
      balance[i] += M-AtoB;
      double BtoA = playersB[bindex]->ReceiveAndForwardMoneyB(AtoB*k);
      balance[bindex] +=AtoB*k - BtoA;
      playersA[i]->RecieveMoneyBack(BtoA);
      balance[i] += BtoA;
    }
  }
  cout << "First round results" << endl;
  outfile << "First round results" << endl;
  for(unsigned int i =0; i < nplayers; i++){
    cout << playersA[i]->GetName() << " " << balance[i] << endl;
    outfile << playersA[i]->GetName() << ", " << balance[i] << endl;
  }
  
  // second game round
  balance = vector<double>(nplayers,0.0);
  for(unsigned int i =0; i < nplayers; i++){
    for(unsigned int j =0; j < nplayers; j++){
      FillVector(playersA);
      FillVector(playersB);
      int bindex = (i+j)%nplayers;
      //cout << "A :" << playersA[i]->GetName() << endl;
      //cout << "B :" << playersB[bindex]->GetName() << endl;
      
      double AtoB = playersA[i]->ReceiveAndForwardMoneyA(M);
      balance[i] += M-AtoB;
      double BtoA = playersB[bindex]->ReceiveAndForwardMoneyB(AtoB*k);
      balance[bindex] +=AtoB*k - BtoA;
      playersA[i]->RecieveMoneyBack(BtoA);
      balance[i] += BtoA;

      AtoB = playersB[bindex]->ReceiveAndForwardMoneyA(M);
      balance[bindex] += M-AtoB;
      BtoA = playersA[i]->ReceiveAndForwardMoneyB(AtoB*k);
      balance[i] +=AtoB*k - BtoA;
      playersB[bindex]->RecieveMoneyBack(BtoA);
      balance[bindex] += BtoA;
    }
  }
  for(unsigned int i =0; i < nplayers; i++){
    for(unsigned int j =0; j < nplayers; j++){
        FillVector(playersA);
	FillVector(playersB);
      int bindex = (i+j)%nplayers;
      //cout << "A :" << playersA[i]->GetName() << endl;
      //cout << "B :" << playersB[bindex]->GetName() << endl;
      
      double AtoB = playersB[i]->ReceiveAndForwardMoneyA(M);
      balance[i] += M-AtoB;
      double BtoA = playersA[bindex]->ReceiveAndForwardMoneyB(AtoB*k);
      balance[bindex] +=AtoB*k - BtoA;
      playersB[i]->RecieveMoneyBack(BtoA);
      balance[i] += BtoA;

      AtoB = playersA[bindex]->ReceiveAndForwardMoneyA(M);
      balance[bindex] += M-AtoB;
      BtoA = playersB[i]->ReceiveAndForwardMoneyB(AtoB*k);
      balance[i] +=AtoB*k - BtoA;
      playersA[bindex]->RecieveMoneyBack(BtoA);
      balance[bindex] += BtoA;
    }
  }


  cout << "Second round results" << endl;
  outfile << "Second round results" << endl;
  for(unsigned int i =0; i < nplayers; i++){
    cout << playersA[i]->GetName() << " " << balance[i] << endl;
    outfile << playersA[i]->GetName() << ", " << balance[i] << endl;
  }




  // third game round
  balance = vector<double>(nplayers,0.0);
  // for(unsigned int i =0; i < nplayers; i++){
  //  cout << playersA[i]->GetName() << " " << balance[i] << endl;
  // }
  for(unsigned int i =0; i < nplayers; i++){
    for(unsigned int j =0; j < nplayers; j++){
      FillVector(playersA);
      FillVector(playersB);
      int bindex = (i+j)%nplayers;
      for(unsigned int nrounds = 0; nrounds < 100; nrounds++){
	//cout << "A :" << playersA[i]->GetName() << endl;
	//cout << "B :" << playersB[bindex]->GetName() << endl;
      
	double AtoB = playersA[i]->ReceiveAndForwardMoneyA(M);
	//cout <<  playersA[i]->GetName() << " " << M-AtoB << endl;
	assert(M-AtoB >= 0);
	balance[i] += M-AtoB;
	double BtoA = playersB[bindex]->ReceiveAndForwardMoneyB(AtoB*k);
	balance[bindex] +=AtoB*k - BtoA;
	//cout << "back: "<< playersB[bindex]->GetName() << " " << BtoA << " of " <<AtoB*k << endl;
	assert(AtoB*k - BtoA >=0);
	playersA[i]->RecieveMoneyBack(BtoA);
	balance[i] += BtoA;
	
	//assert(BtoA >= 0);
	AtoB = playersB[bindex]->ReceiveAndForwardMoneyA(M);
	balance[bindex] += M-AtoB;
	//cout <<  playersB[bindex]->GetName() << " " << AtoB << endl;
	assert(M-AtoB >= 0);
	BtoA = playersA[i]->ReceiveAndForwardMoneyB(AtoB*k);
	balance[i] +=AtoB*k - BtoA;
	assert(AtoB*k - BtoA >=0);
	playersB[bindex]->RecieveMoneyBack(BtoA);
	balance[bindex] += BtoA;
	//cout << "back: "<< playersA[i]->GetName() << " " << BtoA << endl;
	//assert(BtoA >= 0);
      }
    }
  }
  for(unsigned int i =0; i < nplayers; i++){
    for(unsigned int j =0; j < nplayers; j++){
      FillVector(playersA);
      FillVector(playersB);
      int bindex = (i+j)%nplayers;
      for(unsigned int nrounds = 0; nrounds < 100; nrounds++){
	//cout << "A :" << playersA[i]->GetName() << endl;
	//cout << "B :" << playersB[bindex]->GetName() << endl;
      
	double AtoB = playersB[i]->ReceiveAndForwardMoneyA(M);
	balance[i] += M-AtoB;
	double BtoA = playersA[bindex]->ReceiveAndForwardMoneyB(AtoB*k);
	balance[bindex] +=AtoB*k - BtoA;
	playersB[i]->RecieveMoneyBack(BtoA);
	balance[i] += BtoA;

	AtoB = playersA[bindex]->ReceiveAndForwardMoneyA(M);
	balance[bindex] += M-AtoB;
	BtoA = playersB[i]->ReceiveAndForwardMoneyB(AtoB*k);
	balance[i] +=AtoB*k - BtoA;
	playersA[bindex]->RecieveMoneyBack(BtoA);
	balance[bindex] += BtoA;
      }
    }
  }


  cout << "Third round results" << endl;
  outfile << "Third round results" << endl;
  for(unsigned int i =0; i < nplayers; i++){
    cout << playersA[i]->GetName() << " " << balance[i] << endl;
    outfile << playersA[i]->GetName() << ", " << balance[i] << endl;
  }



  // fourth game round
  balance = vector<double>(nplayers,0.0);
  // for(unsigned int i =0; i < nplayers; i++){
  //  cout << playersA[i]->GetName() << " " << balance[i] << endl;
  // }
  for(unsigned int i =0; i < nplayers; i++){
    for(unsigned int j =0; j < nplayers; j++){
      FillVector(playersA);
      FillVector(playersB);
      int bindex = (i+j)%nplayers;
      for(unsigned int nrounds = 0; nrounds < 10000; nrounds++){
	//cout << "A :" << playersA[i]->GetName() << endl;
	//cout << "B :" << playersB[bindex]->GetName() << endl;
      
	double AtoB = playersA[i]->ReceiveAndForwardMoneyA(M);
	//cout <<  playersA[i]->GetName() << " " << M-AtoB << endl;
	assert(M-AtoB >= 0);
	balance[i] += M-AtoB;
	double BtoA = playersB[bindex]->ReceiveAndForwardMoneyB(AtoB*k);
	balance[bindex] +=AtoB*k - BtoA;
	assert(AtoB*k - BtoA >=0);
	playersA[i]->RecieveMoneyBack(BtoA);
	balance[i] += BtoA;
	//cout << "back: "<< playersB[bindex]->GetName() << " " << BtoA << endl;
	assert(BtoA >= 0);
	AtoB = playersB[bindex]->ReceiveAndForwardMoneyA(M);
	balance[bindex] += M-AtoB;
	//cout <<  playersB[bindex]->GetName() << " " << AtoB << endl;
	assert(M-AtoB >= 0);
	BtoA = playersA[i]->ReceiveAndForwardMoneyB(AtoB*k);
	balance[i] +=AtoB*k - BtoA;
	//assert(AtoB*k - BtoA >0);
	playersB[bindex]->RecieveMoneyBack(BtoA);
	balance[bindex] += BtoA;
	//cout << "back: "<< playersA[i]->GetName() << " " << BtoA << endl;
	assert(BtoA >= 0);
      }
    }
  }
  for(unsigned int i =0; i < nplayers; i++){
    for(unsigned int j =0; j < nplayers; j++){
      FillVector(playersA);
      FillVector(playersB);
      int bindex = (i+j)%nplayers;
      for(unsigned int nrounds = 0; nrounds < 10000; nrounds++){
	//cout << "A :" << playersA[i]->GetName() << endl;
	//cout << "B :" << playersB[bindex]->GetName() << endl;
      
	double AtoB = playersB[i]->ReceiveAndForwardMoneyA(M);
	balance[i] += M-AtoB;
	double BtoA = playersA[bindex]->ReceiveAndForwardMoneyB(AtoB*k);
	balance[bindex] +=AtoB*k - BtoA;
	playersB[i]->RecieveMoneyBack(BtoA);
	balance[i] += BtoA;

	AtoB = playersA[bindex]->ReceiveAndForwardMoneyA(M);
	balance[bindex] += M-AtoB;
	BtoA = playersB[i]->ReceiveAndForwardMoneyB(AtoB*k);
	balance[i] +=AtoB*k - BtoA;
	playersA[bindex]->RecieveMoneyBack(BtoA);
	balance[bindex] += BtoA;
      }
    }
  }


  cout << "Fourth round results" << endl;
  outfile << "Fourth round results" << endl;
  for(unsigned int i =0; i < nplayers; i++){
    cout << playersA[i]->GetName() << " " << balance[i] << endl;
    outfile << playersA[i]->GetName() << ", " << balance[i] << endl;
  }

  outfile.close();

}
